#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

static const char *const states = " #*.";
static const int d[] = {-12, 1, 12, -1};

// Execute n steps of a Life-like cellular automaton with arbitrary states (Generations rules), given an initial state and a ruleset.
void do_ca(uint8_t birth, uint8_t survive, uint8_t nstates, int width, int height, uint8_t state[height][width], int n) {
    char neighbor_data[height+2][width+2];
    char (*neighbors)[width+2] = (void *) &neighbor_data + height + 1;
    for (; n--;) {
        memset(neighbors, 0, (height+1)*(width+2) - 1);
        for (int y = 0; y < height; y++) for (int x = 0; x < width; x++) if (state[y][x] == 1) {
            neighbors[y-1][x-1]++;
            neighbors[y-1][x]++;
            neighbors[y-1][x+1]++;
            neighbors[y][x-1]++;
            neighbors[y][x+1]++;
            neighbors[y+1][x-1]++;
            neighbors[y+1][x]++;
            neighbors[y+1][x+1]++;
        }

        for (int y = 0; y < height; y++) for (int x = 0; x < width; x++) {
            uint8_t cstate = state[y][x];
            switch (cstate) {
              case 0:
                if (birth >> (8-neighbors[y][x]) & 1)
                  state[y][x] = 1;
                break;
              case 1:
                if (!(survive >> (8-neighbors[y][x]) & 1))
                  state[y][x] = (cstate + 1) % nstates;
                break;
              default:
                state[y][x] = (cstate + 1) % nstates;
            }
        }
    }
}

void print_state(int width, int height, uint8_t state[height][width]) {
    for (int y = 0; y < height; y++) {
        for (int x = 0; x < width; x++)
            putchar(states[state[y][x]]);
        putchar('\n');
    }
}

int *entry(int input[100]) {
    uint8_t state[10][10];
    for (int y = 0; y < 10; y++) for (int x = 0; x < 10; x++) {
        state[y][x] = input[y*10+x];
    }
    print_state(10, 10, state);
    // run as CGoL for a bit
    do_ca(0x20, 0x30, 2, 10, 10, state, 3);
    print_state(10, 10, state);
    // Seeds is explosive; only use one generation
    do_ca(0x40, 0x00, 2, 10, 10, state, 1);
    // time for its sibling, Brian's Brain
    do_ca(0x40, 0x00, 3, 10, 10, state, 4);
    print_state(10, 10, state);
    // do you like sci-fi?
    do_ca(0x38, 0x40, 4, 10, 10, state, 2);
    print_state(10, 10, state);

    // that was pretty fun. anyway...
    int*p=calloc(100,sizeof(int)),t[144]={[0 ...143]=1};for(int y=0;y<10;y++)for(int x=0;x<10;x++)t[y*12+x+13]=input[y*10+x];
    #define T(v,s)for(i=0;i<4;i++)if(t[n+d[i]]==v){t[n]=s;n+=d[i];p[l++]=i+1;goto e;}
    for(int i,l=0,n=13;n!=130;){T(0,2)T(2,1)e:;}return p;
}
